/* GCC */
#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <ctime>
#include <cmath>
#include <cstring>
#include <string>
#include <vector>
#include <map>
#include <algorithm>
#include <queue>
#include <sstream>
#include <locale.h>

#define X first
#define Y second
#define mp(a, b) make_pair((a), (b))

using namespace std;

bool a[530][530], b[530][530];
map < vector<int>, bool > m;
vector <int> cur(5);
int n, i, j, d, ans1, ans2;
char s[1000];

void dfs(int x, int y)
{
    a[x][y] = false;

    d = 0;
    if(b[x - 1][y] == true) d++;
    if(b[x + 1][y] == true) d++;
    if(b[x][y - 1] == true) d++;
    if(b[x][y + 1] == true) d++;
    cur[d]++;

    if(a[x - 1][y] == true) dfs(x - 1, y);
    if(a[x + 1][y] == true) dfs(x + 1, y);
    if(a[x][y - 1] == true) dfs(x, y - 1);
    if(a[x][y + 1] == true) dfs(x, y + 1);
}

int main()
{
    freopen("test.in", "r", stdin);
    freopen("test.out", "w", stdout);

    //scanf("%d\n", &n);
    scanf("%d", &n);
    gets(s);
    for(i = 0; i < n; i++)
    {
        gets(s);

        /*for(j = 0; j < n; j++)
            cerr << s[j];
        cerr << endl;*/

        for(j = 0; j < n; j++)
            if(s[j] == ' ')
                a[i + 1][j + 1] = b[i + 1][j + 1] = false;
            else
                a[i + 1][j + 1] = b[i + 1][j + 1] = true;
    }

    for(i = 0; i < n + 2; i++)
        a[i][0] = a[i][n + 1] = a[0][i] = a[n + 1][i] = false;

    ans1 = 0;
    for(i = 1; i <= n; i++)
        for(j = 0; j <= n; j++)
            if(a[i][j] == true)
            {
                ans1++;
                fill(cur.begin(), cur.end(), 0);
                dfs(i, j);
                m[cur] = true;
            }
    ans2 = m.size();

    printf("%d %d\n", ans1, ans2);

    return 0;
}









