/* GCC */

#include <fstream>
#include <iostream>
#include <vector>

using namespace std;

int n, count=0;
vector< vector<int> > arr(528, vector<int>(528, 0));
vector<int> size(249, 0);

int u[249], d[249], l[249], r[249];

void show(){
    for(int i=0; i<n; i++){
        for(int z=0; z<n; z++){
            cout<<arr[i][z]<<' ';
        }
        cout<<endl;
    }
}

void setFigure(int x, int y){
    //if figure already been
    bool newFig=true;
    if (x>=1 && arr[x-1][y]>0 && arr[x-1][y]<256){
        arr[x][y]=count;
        newFig=false;
    }
    if (x<n-1 && arr[x+1][y]>0 && arr[x+1][y]<256){
        arr[x][y]=count;
        newFig=false;
    }
    if (y>=1 && arr[x][y-1]>0 && arr[x][y-1]<256){
        arr[x][y]=count;
        newFig=false;
    }
    if (y<n-1 && arr[x][y+1]>0 && arr[x][y+1]<256){
        arr[x][y]=count;
        newFig=false;
    }

    //creating new
    if (newFig){
        count++;
        arr[x][y]=count;
        u[count]=x;
        d[count]=x;
        l[count]=y;
        r[count]=y;
    }

    size[count]++;
        if(x>=1 && arr[x-1][y]==256){
            setFigure(x-1, y);
        }
        if(y>=1 && arr[x][y-1]==256){
            setFigure(x, y-1);
        }
        if(x<n-1 && arr[x+1][y]==256){
            setFigure(x+1, y);
        }
        if(y<n-1 && arr[x][y+1]==256){
            setFigure(x, y+1);
        }


    //changing sizes

    if (x<u[count]) u[count]=x;
    if (x>d[count]) d[count]=x;
    if (y<l[count]) l[count]=y;
    if (y>r[count]) r[count]=y;

    //width[count]=r[count]-l[count];
    //height[count]=d[count]-u[count];
}

bool equalMove(int a, int b){
    int i, z;
    int difByX=l[b]-l[a], difByY=u[b]-u[a];//differences
    for (i=u[a]; i<=d[a]; i++){
        for(z=l[a]; z<=r[a]; z++){
            if ((arr[i][z]!=a && arr[i+difByY][z+difByX]==b) ||
                (arr[i][z]==a && arr[i+difByY][z+difByX]!=b)) {
                    return false;
            }
        }
    }
    return true;
}
bool equalSymmetryY(int a, int b){
    int i, z, c=-2;
    int difByX=r[b]-l[a], difByY=u[b]-u[a];//differences
    for (i=u[a]; i<=d[a]; i++){
        c=-2;
        for(z=l[a]; z<=r[a]; z++){
            c+=2;
            //cout<<arr[i][z]<<arr[i+difByY][z+difByX-c]<<endl;
            if ((arr[i][z]!=a && arr[i+difByY][z+difByX-c]==b) ||
                (arr[i][z]==a && arr[i+difByY][z+difByX-c]!=b)) {
                    return false;
            }
        }
    }
    return true;
}
bool equalSymmetryX(int a, int b){
    int i, z, c=-2;
    int difByX=l[b]-l[a], difByY=d[b]-u[a];//differences
    for (i=u[a]; i<=d[a]; i++){
        c+=2;
        for(z=l[a]; z<=r[a]; z++){
            if ((arr[i][z]!=a && arr[i+difByY-c][z+difByX]==b) ||
                (arr[i][z]==a && arr[i+difByY-c][z+difByX]!=b)) {
                    return false;
            }
        }
    }
    return true;
}
bool equalSymmetryXY(int a, int b){
    int i, z, c=-2, e=-2;
    int difByX=r[b]-l[a], difByY=d[b]-u[a];//differences
    for (i=u[a]; i<=d[a]; i++){
        c+=2;
        e=-2;
        for(z=l[a]; z<=r[a]; z++){
            e+=2;
            if ((arr[i][z]!=a && arr[i+difByY-c][z+difByX-e]==b) ||
                (arr[i][z]==a && arr[i+difByY-c][z+difByX-e]!=b)) {
                    return false;
            }
        }
    }
    return true;
}

bool equalQuater(int a, int b){
    int i, z;
    int dif1=u[b]-l[a], dif2=r[b]+u[a];//differences
    for (i=u[a]; i<=d[a]; i++){
        for(z=l[a]; z<=r[a]; z++){
            if ((arr[i][z]!=a && arr[z+dif1][dif2-i]==b) ||
                (arr[i][z]==a && arr[z+dif1][dif2-i]!=b)) {
                    return false;
            }
        }
    }
    return true;
}
bool equalThreeQuaterSymmetry(int a, int b){ //!!!!!!!!!!!!!!!!!
    int i, z;
    int dif1=d[b]+l[a], dif2=r[b]+u[a];//differences
    for (i=u[a]; i<=d[a]; i++){
        for(z=l[a]; z<=r[a]; z++){
            if ((arr[i][z]!=a && arr[dif1-z][dif2-i]==b) ||
                (arr[i][z]==a && arr[dif1-z][dif2-i]!=b)) {
                    return false;
            }
        }
    }
    return true;
}
bool equalThreeQuater(int a, int b){
    int i, z;
    int dif1=d[b]+l[a], dif2=l[b]-u[a];//differences
    for (i=u[a]; i<=d[a]; i++){
        for(z=l[a]; z<=r[a]; z++){
            if ((arr[i][z]!=a && arr[dif1-z][i+dif2]==b) ||
                (arr[i][z]==a && arr[dif1-z][i+dif2]!=b)) {
                    return false;
            }
        }
    }
    return true;
}
bool equalQuaterSymmetry(int a, int b){
    int i, z;
    int dif1=u[b]-l[a], dif2=l[b]-u[a];//differences
    for (i=u[a]; i<=d[a]; i++){
        for(z=l[a]; z<=r[a]; z++){
            if ((arr[i][z]!=a && arr[dif1+z][dif2+i]==b) ||
                (arr[i][z]==a && arr[dif1+z][dif2+i]!=b)) {
                    return false;
            }
        }
    }
    return true;
}

int main(){
    ifstream fin("test.in");
    ofstream fout("test.out");

    int i, z;
    string q;
    fin>>n;
    getline(fin, q);

    //READING
    for(i=0; i<n; i++){
        getline(fin, q);
        for(z=0; z<n; z++){
            if(q[z]!=' ') arr[i][z]=256;
        }
    }

    //SET FIGURES
    for(i=0; i<n;i++){
        for(z=0; z<n; z++){
            if (arr[i][z]==256){
                //count++;

                setFigure(i, z);
            }
        }
    }




    //if figures are equal
    for(i=1; i<count; i++){
        for(z=i+1; z<=count; z++){
            //if sizes equal
            if(size[i]==size[z] && size[i]!=0){
                //if distances are equal width1==width2, height1==height2
                if (u[i]-d[i]==u[z]-d[z] && r[i]-l[i]==r[z]-l[z]){
                    if (equalMove(i, z) ||
                        equalSymmetryX(i, z) ||
                        equalSymmetryXY(i, z) ||
                        equalSymmetryY(i,z)) {
                        size[z]=0;
                    }
                }
                //if distances are equal height1==width2, width1==height2
                if (d[i]-u[i]==r[z]-l[z] && r[i]-l[i]==d[z]-u[z]){
                     if (equalQuater(i, z) ||
                        equalQuaterSymmetry(i, z) ||
                        equalThreeQuater(i, z) ||
                        equalThreeQuaterSymmetry(i,z)) {
                        size[z]=0;
                    }
                }
            }
        }
    }


    //File out
    int answer=0;
    for(i=1; i<=count; i++){
        if (size[i]!=0) answer++;
    }

    fout<<count<<' '<<answer<<endl;

    fin.close();
    fout.close();
    return 0;
}
