/* GCC */
#include "stdio.h"

#include <cmath>
#include <utility>
#include <vector>
#include <algorithm>


using namespace std;

long long gcd(long long q,long long w){
if(q>w) return gcd(w,q); else
if(q==0) return w; else
    return gcd(w%q,q);
}

pair<long long,long long> Di (pair<pair<long long,long long> ,pair<long long,long long> > PP,  pair<pair<long long,long long>,long long> LL){
long long a=LL.first.first;
long long b=LL.first.second;
long long c=LL.second;
long long x1=PP.first.first;
long long x2=PP.first.second;
long long y1=PP.second.first;
long long y2=PP.second.second;

long long cc=labs(a*x1*y2+b*y1*x2+c*x2*y2);
long long zz=x2*y2* ((long long)(sqrt(a*a+b*b)+0.1));
long long ddd=gcd(labs(cc),labs(zz));
cc/=ddd;
zz/=ddd;
return make_pair(cc,zz);

}


pair<long long,long long>Add(pair <long long,long long> w,pair<long long,long long> e){
 long long cc;
 long long zz;


 cc=w.first*e.second+w.second*e.first;
 zz=w.second*e.second;

 long long dd=gcd(labs(cc),labs(zz));
 //printf("%d %d\n",cc,zz);
 cc/=dd;

 zz/=dd;

 if (zz<0){zz=-zz;
 cc=-cc;}

 return make_pair(cc,zz);
}

void PR(pair<long long,long long> S){
printf("%I64d",S.first);
if (S.second!=1) printf("/%I64d",S.second);

}

void PRR(pair<pair<long long,long long>,pair<long long,long long> > S){
    PR(S.first);
    printf(" ");
    PR(S.second);


}



int main(){



 freopen("motel.in","r",stdin);
 freopen("motel.out","w",stdout);

long long n;
scanf("%I64d",&n);
vector<pair<long long,long long> > P1,P2;
P1.resize(n+2);
P2.resize(n+2);
vector <pair<pair<long long,long long>,long long> > L;
L.resize(n+2);
for(long long i=0;i<n;i++)
{long long x1,x2,y1,y2;
scanf("%I64d%I64d%I64d%I64d",&x1,&y1,&x2,&y2);
P1[i].first=x1;
P1[i].second=y1;
P2[i].first=x2;
P2[i].second=y2;

L[i].first.first=y2-y1;
L[i].first.second=x1-x2;
L[i].second=-(y2-y1)*x1-(x1-x2)*y1;
long long d=gcd(gcd(labs(L[i].first.first),labs(L[i].first.second)),labs(L[i].second));//cmath
L[i].first.first/=d;
L[i].first.second/=d;
L[i].second/=d;

if( (L[i].first.first<0)||((L[i].first.first==0)&&(L[i].first.second<0)))
        {L[i].first.first=-L[i].first.first;L[i].first.second=-L[i].first.second;L[i].second=-L[i].second;}
}

vector <pair<pair<long long,long long>,pair<long long,long long> > > P;
for(long long i=0;i<n;i++)
for(long long j=i+1;j<n;j++){
 long long a1=L[i].first.first;
 long long b1=L[i].first.second;
 long long c1=L[i].second;

 long long a2=L[j].first.first;
 long long b2=L[j].first.second;
 long long c2=L[j].second;

 if(a1*b2==a2*b1) continue;

 long long xc=c2*b1-c1*b2;
 long long xz=a1*b2-a2*b1;
 long long yc=c2*a1-c1*a2;
 long long yz=b1*a2-b2*a1;

 long long d1=gcd(labs(xc),labs(xz));
 xc/=d1;
 xz/=d1;
 if(xz<0){xz=-xz;xc=-xc;}

 long long d2=gcd(labs(yc),labs(yz));
 yc/=d2;
 yz/=d2;
 if(yz<0){yz=-yz;yc=-yc;}

 P.push_back(make_pair(make_pair(xc,xz),make_pair(yc,yz)));


}
if(P.size()==0){




for(long long i=0;i<n;i++) P.push_back(make_pair(make_pair(P1[i].first,1),make_pair(P1[i].second,1)));

sort(P.begin(),P.end());
P.erase(unique(P.begin(),P.end()),P.end());
vector <pair<long long,long long> > R;
//R.clean();
R.resize(P.size()+2);

for(long long i=0;i<P.size();i++)
{
    pair<long long,long long> q;
    q.first=0;
    q.second=1;

    for(long long j=0;j<n;j++)
        q=Add(q,Di(P[i],L[j]));
    R[i]=q;

}//printf("!");
long long mi=0;

for(long long i=0;i<P.size();i++)
    if(R[i].first*R[mi].second<R[mi].first*R[i].second) mi=i;

    long long k=0;
for(long long i=0;i<P.size();i++)
   if(R[i].first*R[mi].second==R[mi].first*R[i].second) k++;

   PR(R[mi]);
printf("\n");
  printf("%I64d\n",-k);

  for(long long i=0;i<P.size();i++)
   if(R[i].first*R[mi].second==R[mi].first*R[i].second)  {printf("%I64d %I64d %I64d\n",L[i].first.first,L[i].first.second,L[i].second);  }

}






else{

sort(P.begin(),P.end());
P.erase(unique(P.begin(),P.end()),P.end());
vector <pair<long long,long long> > R;
//R.clean();
R.resize(P.size()+2);

for(long long i=0;i<P.size();i++)
{
    pair<long long,long long> q;
    q.first=0;
    q.second=1;

    for(long long j=0;j<n;j++)
        q=Add(q,Di(P[i],L[j]));
    R[i]=q;

}//printf("!");
long long mi=0;

for(long long i=0;i<P.size();i++)
    if(R[i].first*R[mi].second<R[mi].first*R[i].second) mi=i;

    long long k=0;
for(long long i=0;i<P.size();i++)
   if(R[i].first*R[mi].second==R[mi].first*R[i].second) k++;

   PR(R[mi]);
printf("\n");
  printf("%I64d\n",k);

  for(long long i=0;i<P.size();i++)
   if(R[i].first*R[mi].second==R[mi].first*R[i].second)  {PRR(P[i]);printf("\n");  }


}

fclose(stdin);
fclose(stdout);

return 0;
}
